seo:
  title: How open source contributions accelerate GitLab Secure
  description: >-
    Community contributions and an open integration framework allows anyone to
    extend GitLab Secure
  ogTitle: How open source contributions accelerate GitLab Secure
  ogDescription: >-
    Community contributions and an open integration framework allows anyone to
    extend GitLab Secure
  noIndex: false
  ogImage: images/blog/hero-images/group-rowing-collaboration.jpg
  ogUrl: https://about.gitlab.com/blog/integrating-with-gitlab-secure
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/integrating-with-gitlab-secure
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "How open source contributions accelerate GitLab Secure",
            "author": [{"@type":"Person","name":"Taylor McCaslin"}],
            "datePublished": "2020-10-22",
          }

content:
  title: How open source contributions accelerate GitLab Secure
  description: >-
    Community contributions and an open integration framework allows anyone to
    extend GitLab Secure
  authors:
    - Taylor McCaslin
  heroImage: images/blog/hero-images/group-rowing-collaboration.jpg
  date: '2020-10-22'
  body: >

    When you think about security you probably imagine locks, gates, and closed
    systems. This is the more traditional approach to security but modern
    security is much more open and collaborative. If you want to build the most
    secure systems, there is nothing better than building those systems in the
    open. Open security practices allow you to get fast feedback from a broad
    audience with diverse perspectives, helping you build better more holistic
    solutions. That's our approach to building [GitLab
    Secure](/stages-devops-lifecycle/secure/) at GitLab. We're leveraging
    amazing open source security projects, the collective contribution of the
    wider community, and providing an open integration system for anyone to
    build on top of GitLab security scanners.


    ## Shifting left


    Traditional security approaches are opaque and late in the development life
    cycle. Security scans are performed by isolated security experts long after
    developers write code, often after it's deployed to production. GitLab aims
    to make security an integrated and continuous process. That's why we've
    built [GitLab Secure directly integrated into the DevOps life
    cycle](/solutions/dev-sec-ops/). We are taking security tools and "shifting
    left" to make these tools more accessible to developers earlier in the
    development life cycle and integrated directly into developers' workflows.


    ![Traditional Security vs DevSecOps with
    GitLab](https://about.gitlab.com/images/blogimages/traditional-security-vs-integrated.png)


    We created a detailed survey to learn more about the [2020 DevSecOps
    Landscape](/developer-survey/#security). The results of the survey indicated
    that security is still a significant hurdle for most organizations that use
    DevOps, and show:


    - Only 13% of companies give developers access to the results of
    [application security](/topics/devsecops/) tests

    - Over 42% said testing happens too late in the lifecycle

    - 36% reported it was hard to understand, process, and fix any discovered
    vulnerabilities

    - 31% found prioritizing vulnerability remediation an uphill battle


    These statistics illustrate why we are building security scanning directly
    into GitLab with our Secure features. We want to provide integrated security
    tools to broaden access and make it easier for everyone using GitLab to
    write more secure code.


    ## Integrating security tools into everyday workflows


    GitLab Secure enables accurate, automated, and continuous assessment of your
    applications and services, allowing users to proactively identify
    vulnerabilities and weaknesses to minimize security risk. Secure is not an
    additional step in your development process nor an additional tool to
    introduce to your software stack. It is woven into your DevOps cycle, which
    allows you to adapt security testing and processes to your developers (and
    not the other way around).


    Today [GitLab Secure](/stages-devops-lifecycle/secure/) offers support for a
    variety of security scanning tools including:

    - [Static Application Security Testing
    (SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)

    - [Dynamic Application Security Testing
    (DAST)](https://docs.gitlab.com/ee/user/application_security/dast/)

    - [Container
    Scanning](https://docs.gitlab.com/ee/user/application_security/container_scanning/)

    - [Dependency
    Scanning](https://docs.gitlab.com/ee/user/application_security/dependency_scanning/)

    - [License
    Scanning](https://docs.gitlab.com/ee/user/compliance/license_compliance/index.html)

    - [Secret
    Detection](https://docs.gitlab.com/ee/user/application_security/secret_detection/)

    - [API
    Fuzzing](https://docs.gitlab.com/ee/user/application_security/api_fuzzing/)

    - [Coverage
    Fuzzing](https://docs.gitlab.com/ee/user/application_security/coverage_fuzzing/)


    All of these tools provide unique approaches to finding security problems.
    No one tool is best at everything, so we wanted to provide a way to leverage
    many tools in an integrated way, so you're always getting the most relevant
    security results. Take a look at how GitLab Secure integrates all these
    tools into common developer workflows on GitLab:


    <figure class="video_container">
      <iframe src="https://www.youtube.com/embed/XnYstHObqlA" frameborder="0" allowfullscreen="true"> </iframe>
    </figure>


    ## Democratizing security


    With GitLab Secure, we've laid the foundation for bringing security tools
    directly into developers' workflows. At GitLab, we believe in a world where
    [everyone can contribute](/company/culture/#everyone-can-contribute).
    [Collaboration](/handbook/values/#collaboration) and
    [transparency](/handbook/values/#transparency) are part of our core values.
    This approach changes the way we build security features. That's why as part
    of our [community stewardship promise](/company/stewardship/#promises) we've
    made all our open source based [SAST scanners available for all
    users](/releases/2020/08/22/gitlab-13-3-released/#sast-security-analyzers-available-for-all),
    we offer [open source projects and nonprofits free access to our best
    features](/solutions/open-source/join/), and we've created a [security
    scanner integration
    framework](https://docs.gitlab.com/ee/development/integrations/secure.html)
    to allow anyone to contribute security scan tools. Our entire [product
    strategy and vision](/direction/secure/) is also open source, so everyone
    can understand our vision for an integrated, accessible, and democratic
    approach to security. Together we can build a more open and modern security
    approach that helps developers everywhere write more secure code.


    ## Integrate with GitLab Secure


    Out of the box, GitLab provides a variety of pre-integrated and actively
    managed open source security tools, such as [SAST's 16
    analyzers](https://docs.gitlab.com/ee/user/application_security/sast/#supported-languages-and-frameworks)
    that all support automatic language detection to always run the most
    relevant security tool. While GitLab will continue to update and build
    first-party integrations we wanted to ensure that GitLab contributors and
    integration partners could easily extend GitLab Secure for third-party
    tools. Our [open integration
    framework](https://docs.gitlab.com/ee/development/integrations/secure.html)
    makes it easy for anyone to leverage all of the [features of GitLab
    Secure](/features/#secure) with any scanning tool they may want to
    integrate. You can see all the tools GitLab users have requested support for
    and even add your own request in our [tracking
    epic](https://gitlab.com/groups/gitlab-org/-/epics/297).


    ## Community contributions


    With our open integration framework we've seen members of the [GitLab
    community](/community/) contribute additional security scanners, help
    maintain the existing open source scanners we offer and expand the list of
    supported languages and frameworks we support. Our community contributors
    are helping every GitLab user have access to more accurate, sophisticated,
    and relevant security results. Here are some recent community contribution
    highlights:


    - [Mobile SAST support via
    MobSF](https://gitlab.com/gitlab-org/gitlab/-/issues/233777) (contribution
    by [@williams.brian-heb](https://gitlab.com/williams.brian-heb)) - [GitLab
    13.5 Release MVP](/releases/2020/10/22/gitlab-13-5-released/#mvp)

    - [Adding Helm Chart
    support](https://gitlab.com/gitlab-org/gitlab/-/issues/36755) (contribution
    by [@agixid](https://gitlab.com/agixid))

    - [Performance improvements to Fuzz
    testing](https://gitlab.com/gitlab-org/security-products/analyzers/fuzzers/pythonfuzz/-/merge_requests/1)
    (contribution by [@jvoisin](https://gitlab.com/jvoisin))

    - [Updates to secret
    detection](https://gitlab.com/gitlab-org/gitlab/-/issues/205172)
    (contribution by [@tnir](https://gitlab.com/tnir))

    - [Dependency scanning
    buxfixes](https://gitlab.com/gitlab-org/gitlab/-/issues/205172)
    (contribution by [@fcbrooks](https://gitlab.com/fcbrooks))

    - [Updates to Security Scanner underlying operating
    systems](https://gitlab.com/gitlab-org/gitlab/-/issues/216781) (contribution
    by [@J0WI](https://gitlab.com/J0WI))

    - [Contributions for .NET Framework
    Support](https://gitlab.com/gitlab-org/security-products/analyzers/security-code-scan/-/merge_requests/14)
    (contribution by [@agixid](https://gitlab.com/agixid))

    - [See the full list of Secure community
    contributions](https://gitlab.com/gitlab-org/gitlab/-/issues?scope=all&utf8=%E2%9C%93&state=all&label_name[]=Community%20contribution&label_name[]=devops%3A%3Asecure)


    The open source nature of GitLab allows the community to help improve,
    maintain, and contribute features within GitLab. This is the ultimate value
    of open source. Even if we don't offer something, you can always extend or
    modify the behavior of GitLab to accomplish your goal. When compared to
    closed-source Security vendors, this is a huge benefit. The impact these
    contributions have is massive as GitLab Secure is used by tens of thousands
    of customers and performs hundreds of thousands of security scans every
    month. If you are interested in contributing, check out our [contributor
    program](/community/contribute/) and [contributor
    documentation](https://docs.gitlab.com/ee/development/contributing/).


    ## Integration partners


    Community contributions aren't the only way GitLab Secure is being extended.
    We have a variety of integration partners who provide security integrations
    that further expand the suite of security tools available to GitLab users.
    Check out the [GitLab Security integrations](/partners/#security) our
    partners offer. If you are a security vendor interested in integrating with
    GitLab, [join our partner
    program](/handbook/alliances/integration-instructions/) today.


    ## Looking ahead


    We've come a long way in the past few years with GitLab Secure and we're not
    done yet. Our [vision is bold (and open source)](/direction/secure/) and
    [our investment in security is
    large](https://internal.gitlab.com/handbook/product/investment/). [Security
    is a team effort](/direction/secure/#security-is-a-team-effort) and we hope
    you'll join us on our mission to help developers write more secure code.


    ## Read more about GitLab SAST:


    * GitLab [Secure Direction](/direction/secure/)

    * Learn more about [integrating with GitLab
    Secure](https://docs.gitlab.com/ee/development/integrations/secure.html)

    * View the latest [October 2020 GitLab security
    trends](/blog/2020/10/06/gitlab-latest-security-trends/)


    Cover image by [Mitchell Luo](https://unsplash.com/@mitchel3uo) on
    [Unsplash](https://unsplash.com/s/photos/rowing-team)

    {: .note}
  category: Open Source
  tags:
    - CI/CD
    - DevOps
    - security
    - community
    - contributors
    - open source
config:
  slug: integrating-with-gitlab-secure
  featured: false
  template: BlogPost
